GEN = {}
GEN.gName = 'Caucasus Sandbox'
GEN.gVersion = '1.12'
-- by Draken35
  --[[ Eras:
          1 = Korean war (no SAMs)                                                              (Mig15)
          2 = Vietnam (SA-2)                                                                     (Mig19,Mig21)
          3 = Cold War 70's (SA-3, SA-6, SA-8)                                                   (Mig19,Mig21,Mig23)
          4 = Cold War 70's (SA-3, SA-6, SA-8, SA-9, SA-18)                                      (Mig19,Mig21,Mig23)
          5 = Cold War 70's (SA-3, SA-5, SA-6, SA-8, SA-9,SA-18)                                  (Mig19,Mig21,Mig23)
          6 = Late Cold War  (SA-6, SA-8, SA-11, SA-15)                                          (Mig23,Mig25,Mig29A)
          7 = Late Cold War  (SA-6, SA-8, SA-9, SA-18, SA-11, SA-13, SA-15, SA-19)               (Mig23,Mig25,Mig29A)
          8 = Late Cold War  (SA-5,SA-6, SA-8, SA-9, SA-18 SA-10, SA-11, SA-13, SA-15, SA-19)     (Mig23,Mig25,Mig29A)
          9 = Moderm        ( SA-11, SA-13, SA-15, SA-18, SA-19)                                  (Mig29S,Mig31,Su27,Su33)
          10= Moderm        (SA-10, SA-11, SA-13, SA-15, SA-18, SA-19)                              (Mig29S,Mig31,Su27,Su33)

  --]]


--#################################################################################################################################################
-- #############   Configuration (mission specific)																		                                        			############### 
--#################################################################################################################################################
do -- Variables
  GEN.samDetectionProb  = 75 -- percent
  GEN.interceptorsProb  = 35 -- percent
  GEN.MaxRedAirbases    = 1  -- that might deploy interceptors
  GEN.MaxTargets        = 2  -- mission targets (max 10 because of menu UI limitations)


end
do -- Templates
--		            groupName,	          displayName,	    class,  	   side,                  era,                  disperse,   size,     properties (table, free format)	
  MGT.addTemplate( 'R-CP'  ,            'IADS HQ'	,       'CP',         coalition.side.RED, 	{2,3,4,5,6,7,8,9,10},      0,		  50,	      {'Suppresion','IADS-CP'})  
  MGT.addTemplate( 'R-EWR-1',           'EWR Site',       'EWR',        coalition.side.RED, 	{2,3,4,5,6,7,8,9,10},      0,		  50,	      {'Suppresion','IADS-EWR'})  
  MGT.addTemplate( 'R-EWR-2',           'EWR Site',       'EWR',        coalition.side.RED, 	{2,3,4,5,6,7,8,9,10},      0,		  50,	      {'Suppresion','IADS-EWR'})    
  
  MGT.addTemplate( 'R-SPAAA-ZSU23',     'ZSU-23-4',       'SPAAA',      coalition.side.RED, 	{2,3,4,5,6,7,8},            0,		  10,	    {'Suppresion',})  
  MGT.addTemplate( 'R-SPAAA-ZSU57',     'ZSU-57-2',       'SPAAA',      coalition.side.RED, 	{2,3,4},                    0,		  10,	    {'Suppresion',})  
  MGT.addTemplate( 'R-SPAAA-ZU23',      'ZU-23-2/375',    'SPAAA',      coalition.side.RED, 	{0},                        0,		  10,	    {'Suppresion',})    
  MGT.addTemplate( 'R-AAAL-zu23',       'ZU-23-2',        'AAA-L',      coalition.side.RED, 	{0},                        0,		  20,	    {'Suppresion',}) 
  MGT.addTemplate( 'R-AAAM-s60',        'S-60',           'AAA-M',      coalition.side.RED, 	{0},                        0,		  20,	    {'Suppresion',})  
  MGT.addTemplate( 'R-AAAH-ks19',       'KS-19/SON-9',    'AAA-H',      coalition.side.RED, 	{0},                        0,		  60,	    {'Suppresion',})  
  MGT.addTemplate( 'R-AAAH-ks19',       'KS-19/SON-9',    'SAM',        coalition.side.RED, 	{1},                        0,		  60,	    {'Suppresion',})    
  MGT.addTemplate( 'R-HMG-DSHK',        'DSHK 12.7mm',    'HMG',        coalition.side.RED, 	{0},                        0,		   5,	    {'Suppresion',})      
  
  MGT.addTemplate( 'R-SAM-sa2',         'SA-2 Site',      'SAM',        coalition.side.RED, 	{2},                        0,		 400,	    {'Suppresion','IADS-SAM'})      
  MGT.addTemplate( 'R-SAM-sa3',         'SA-3 Site',      'SAM',        coalition.side.RED, 	{3,4,5},                    0,		 200,	    {'Suppresion','IADS-SAM'}) 
  MGT.addTemplate( 'R-SAM-sa5',         'SA-5 Site',      'LRSAM',      coalition.side.RED, 	{5,8},                      0,		 300,	    {'Suppresion','IADS-SAM'})   
  MGT.addTemplate( 'R-SAM-sa6',         'SA-6 Btty.',     'SAM',        coalition.side.RED, 	{3,4,5,6,7,8},              0,		 300,	    {'Suppresion','IADS-SAM'})   
  MGT.addTemplate( 'R-SHORAD-sa8',      'SA-8',           'SHORAD',     coalition.side.RED, 	{3,4,5,6,7,8},              0,		  10,	    {'Suppresion','IADS-SAM'}) 
  MGT.addTemplate( 'R-MPDS-sa9',        'SA-9',           'MPDS',       coalition.side.RED, 	{5,7,8},                    0,		  10,	    {'Suppresion'})   
  MGT.addTemplate( 'R-SAM-sa10',        'SA-10 Site',     'LRSAM',      coalition.side.RED, 	{8,10},                     0,		 400,	    {'Suppresion','IADS-SAM'})     
  MGT.addTemplate( 'R-SAM-sa11',        'SA-11',          'SAM',        coalition.side.RED, 	{6,7,8,9,10},               0,		 200,	    {'Suppresion','IADS-SAM'})   
  MGT.addTemplate( 'R-MPDS-sa13',       'SA-13',          'MPDS',       coalition.side.RED, 	{7,8,9,10},                 0,		  10,	    {'Suppresion'})   
  MGT.addTemplate( 'R-SHORAD-sa15',     'SA-15',          'SHORAD',     coalition.side.RED, 	{6,7,8,9,10},               0,		  10,	    {'Suppresion','IADS-SAM'})   
  MGT.addTemplate( 'R-MPDS-sa18',       'SA-18',          'MPDS',       coalition.side.RED, 	{5,7,8,9,10},               0,		  10,	    {'Suppresion'})    
  MGT.addTemplate( 'R-SPAAA-sa19',      'SA-19',          'MPDS',       coalition.side.RED, 	{7,8,9,10},                 0,		  10,	    {'Suppresion'})   
  MGT.addTemplate( 'R-SPAAA-sa19',      'SA-19',          'SPAAA',      coalition.side.RED, 	{7,8,9,10},                 0,		  10,	    {'Suppresion'})    
  
     
  MGT.addTemplate( 'R-Decoy-1',         'SA-2 Site',      'DECOY',      coalition.side.RED, 	{2},                         0,		 400,	    {})      
  MGT.addTemplate( 'R-Decoy-2',         'SA-3 Site',      'DECOY',      coalition.side.RED, 	{3,4,5},                     0,		 200,	    {}) 
  MGT.addTemplate( 'R-Decoy-5',         'SA-5 Site',      'DECOY',      coalition.side.RED, 	{5,8},                       0,		 300,	    {})     
  MGT.addTemplate( 'R-Decoy-3',         'SA-6 Btty.',     'DECOY',      coalition.side.RED, 	{3,4,5,6,7,8},               0,		 300,	    {}) 
  MGT.addTemplate( 'R-Decoy-4',         'SA-8',           'DECOY',      coalition.side.RED, 	{3,4,5,6,7,8},               0,		  10,	    {})   
  MGT.addTemplate( 'R-Decoy-6',         'SA-11',          'DECOY',      coalition.side.RED, 	{6,7,8,9,10},                0,		 200,	    {})     
  MGT.addTemplate( 'R-Decoy-7',         'SA-15',          'DECOY',      coalition.side.RED, 	{6,7,8,9,10},                0,		  10,	    {})     
  MGT.addTemplate( 'R-Decoy-8',         'SA-10 site',     'DECOY',      coalition.side.RED, 	{8,10},                      0,		 400,	    {})    
  
  MGT.addTemplate( 'R-INT-mig15',       'Mig-15',         'INT',        coalition.side.RED, 	{1},                         0,		   0,	    {})  
  MGT.addTemplate( 'R-INT-mig19',       'Mig-19',         'INT',        coalition.side.RED, 	{2,3},                       0,		   0,	    {})    
  MGT.addTemplate( 'R-INT-mig21',       'Mig-21',         'INT',        coalition.side.RED, 	{2,3,4,5},                   0,		   0,	    {})  
  MGT.addTemplate( 'R-INT-mig23',       'Mig-23',         'INT',        coalition.side.RED, 	{3,4,5,6,7,8},               0,		   0,	    {})  
  MGT.addTemplate( 'R-INT-mig25',       'Mig-25',         'INT',        coalition.side.RED, 	{6,7,8},                     0,		   0,	    {})  
  MGT.addTemplate( 'R-INT-mig29A',      'Mig-29A',        'INT',        coalition.side.RED, 	{6,7,8},                     0,		   0,	    {})   
  MGT.addTemplate( 'R-INT-mig29S',      'Mig-29S',        'INT',        coalition.side.RED, 	{9,10},                      0,		   0,	    {})   
  MGT.addTemplate( 'R-INT-mig31',       'Mig-31',         'INT',        coalition.side.RED, 	{9,10},                      0,		   0,	    {})  
  MGT.addTemplate( 'R-INT-su27',        'Su-27',          'INT',        coalition.side.RED, 	{9,10},                      0,		   0,	    {}) 
  MGT.addTemplate( 'R-INT-su33',        'Su-33',          'INT',        coalition.side.RED, 	{9,10},                      0,		   0,	    {})     
  
  MGT.addTemplate( 'B-EW-S3B',          'S-3B (EW)',      'EW',         coalition.side.BLUE, 	{2,3,4,5,6,7,8,9,10},        0,		   0,	    {'CVN'}) 
  MGT.addTemplate( 'B-SEAD-AV8B',       'AV-8B',          'SEAD',       coalition.side.BLUE, 	{3,4,5,6,7,8,9,10},          0,		   0,	    {'LHA','basket'})
  MGT.addTemplate( 'B-CAP-AV8B',        'AV-8B',          'CAP',        coalition.side.BLUE, 	{3,4,5,6,7,8,9,10},          0,		   0,	    {'LHA','basket'})
  MGT.addTemplate( 'B-CAP-F86F',        'F-86F',          'CAP',        coalition.side.BLUE, 	{1},                         0,		   0,	    {})
  MGT.addTemplate( 'B-SEAD-A4E',        'A-4E',           'SEAD',       coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {'CVN','basket'})
  MGT.addTemplate( 'B-SEAD-F4E',        'F-4E',           'SEAD',       coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {'boom'})   
  MGT.addTemplate( 'B-CAP-F4E',         'F-4E',           'CAP',        coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {'boom'})   
  MGT.addTemplate( 'B-SEAD-AJS37',      'AJS37',          'SEAD',       coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {})   
  MGT.addTemplate( 'B-CAP-AJS37',       'AJS37',          'CAP',        coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {})    
  MGT.addTemplate( 'B-CAP-F5E',         'F-5E',           'CAP',        coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {})
  MGT.addTemplate( 'B-CAP-F1CE',        'F1CE',           'CAP',        coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {})     
  MGT.addTemplate( 'B-CAP-F1EE',        'F1EE',           'CAP',        coalition.side.BLUE, 	{2,3,4,5},                   0,		   0,	    {})     
  MGT.addTemplate( 'B-CAP-F16A',        'F-16A',          'CAP',        coalition.side.BLUE,  {3,4,5},                     0,		   0,	    {'boom'}) 
  MGT.addTemplate( 'B-CAP-M2000C',      'M-2000C',        'CAP',        coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'basket'}) 
  MGT.addTemplate( 'B-CAP-F14A',        'F-14A',          'CAP',        coalition.side.BLUE,  {2,3,4,5},                   0,		   0,	    {'CVN','basket'})      
  MGT.addTemplate( 'B-CAP-F14B',        'F-14B',          'CAP',        coalition.side.BLUE,  {6,7,8},                     0,		   0,	    {'CVN','basket'})    
  MGT.addTemplate( 'B-CAP-F16C',        'F-16C',          'CAP',        coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'boom'}) 
  MGT.addTemplate( 'B-SEAD-F16C',       'F-16C',          'SEAD',       coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'boom'})  
  MGT.addTemplate( 'B-CAP-F15C',        'F-15C',          'CAP',        coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'boom'})   
  MGT.addTemplate( 'B-CAP-FA18C',       'F/A-18C',        'CAP',        coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'CVN','basket'}) 
  MGT.addTemplate( 'B-SEAD-FA18C',      'F/A-18C',        'SEAD',       coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'CVN','basket'})   
  MGT.addTemplate( 'B-EW-FA18C',        'F/A-18C',        'EW',         coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'CVN','basket'})   
  MGT.addTemplate( 'B-SEAD-Tornado',    'Tornado GR4',    'SEAD',       coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'basket'})   
  MGT.addTemplate( 'B-EW-Tornado',      'Tornado GR4',    'EW',         coalition.side.BLUE,  {6,7,8,9,10},                0,		   0,	    {'basket'})    
  
end-- Templates
do -- deployment settings										
  GEN.DEF_IADS = {     	
                {
                  name = 'CP',  border = 'AOR', class = 'CP'	, zoneQty = 12, deployZoneQty = mist.random(1,2), zonePrefix = 'cp', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = true, missionRadius = 100, missionName = 'IADS C2', preciseMission = 250,
                  components = {
                      {class = 'SPAAA'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},
                      {class = 'SHORAD'		,	minPerSite = 1 , maxPerSite = 1, minDist =  500, maxDist =  1500, probPerSite = 50, side = coalition.side.RED},  
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                      
                  }
                },      
                {
                  name = 'EWR',  border = 'AOR', class = 'EWR'	, zoneQty = 12, deployZoneQty = mist.random(1,2), zonePrefix = 'EWR', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = true, missionRadius = 100, missionName = 'IADS EWR', preciseMission = 0,
                  components = {
                      {class = 'SPAAA'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},
                      {class = 'SHORAD'		,	minPerSite = 1 , maxPerSite = 1, minDist =  500, maxDist =  1500, probPerSite = 50, side = coalition.side.RED},    
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  }
                },  
                {
                  name = 'SAM 1',  border = 'AOR', class = 'SAM'	, zoneQty = 12, deployZoneQty = 1, zonePrefix = 'sam-1', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 70 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},     
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  }
                },                  
                {
                  name = 'SAM 2',  border = 'AOR', class = 'SAM'	, zoneQty = 12, deployZoneQty = 1, zonePrefix = 'sam-2', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 70 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},  
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  }
                },                  
                 {
                  name = 'SAM 3',  border = 'AOR', class = 'SAM'	, zoneQty = 12, deployZoneQty = 1, zonePrefix = 'sam-3', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 70 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},  
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  }
                },                 
                  {
                  name = 'SAM 4',  border = 'AOR', class = 'SAM'	, zoneQty = 12, deployZoneQty = 1, zonePrefix = 'sam-4', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 70 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},    
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  }
                },  
                  {
                  name = 'SAM 5',  border = 'AOR', class = 'SAM'	, zoneQty = 12, deployZoneQty = 1, zonePrefix = 'sam-5', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 70 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                    }
                  },
                  {
                  name = 'SAM LR',  border = 'AOR', class = 'LRSAM'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'lrsam', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 80 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'SAM Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                          
                  } 
                }
                                       
              }   -- IADS 
  GEN.DEF_AAAH= {     	

                {
                  name = 'AAA-H 1',  border = 'AOR', class = 'AAA-H'	, zoneQty = 12, deployZoneQty = 2, zonePrefix = 'sam-1', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                             
                  }
                },                  
                {
                  name = 'AAA-H 2',  border = 'AOR', class = 'AAA-H'	, zoneQty = 12, deployZoneQty = 2, zonePrefix = 'sam-2', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},  
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  350, maxDist =  900, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                           
                  }
                },                  
                 {
                  name = 'AAA-H 3',  border = 'AOR', class = 'AAA-H'	, zoneQty = 12, deployZoneQty = 2, zonePrefix = 'sam-3', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED},   
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  350, maxDist =  900, probPerSite = 100, side = coalition.side.RED},
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                       
                  }
                },                 
                  {
                  name = 'AAA-H 4',  border = 'AOR', class = 'AAA-H'	, zoneQty = 12, deployZoneQty = 2, zonePrefix = 'sam-4', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  350, maxDist =  900, probPerSite = 100, side = coalition.side.RED},  
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                       
                  }
                },  
                  {
                  name = 'AAA-H 5',  border = 'AOR', class = 'AAA-H'	, zoneQty = 12, deployZoneQty = 2, zonePrefix = 'sam-5', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  350, maxDist =  900, probPerSite = 100, side = coalition.side.RED},  
                      {class = 'HMG'	  	,	minPerSite = 0 , maxPerSite = 2, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                       
                  }
                },                         
              }   -- DEF_AAAH 
  GEN.DEF_ABDEF= {     	
                {
                  name = 'ABDEF',  border = 'AOR', class = 'SPAAA'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'ABDEF', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                  }
                },                  
                {
                  name = 'ABDEF',  border = 'AOR', class = 'AAA-L'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'ABDEF', 	minPerZone = 1 , maxPerZone = 2 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                  }
                },    
                {
                  name = 'ABDEF',  border = 'AOR', class = 'AAA-M'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'ABDEF', 	minPerZone = 1 , maxPerZone = 2 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                  }
                },    
                {
                  name = 'ABDEF',  border = 'AOR', class = 'MPDS'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'ABDEF', 	minPerZone = 1 , maxPerZone = 2 ,
                  probPerZone = 30 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                  }
                },  
                {
                  name = 'ABDEF',  border = 'AOR', class = 'HMG'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'ABDEF', 	minPerZone = 0 , maxPerZone = 4 ,
                  probPerZone = 30 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                  }
                },                  
              }      
              
              
  GEN.DEF_targetDef = {     	
                {
                  name = 'AAA-H 1',  border = 'AOR', class = 'AAA-L'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = '', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'HMG'	  	,	minPerSite = 1 , maxPerSite = 3, minDist =  150, maxDist =  300, probPerSite = 100, side = coalition.side.RED},                    
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 2, minDist =  250, maxDist =  600, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-M'		,	minPerSite = 0 , maxPerSite = 1, minDist =  350, maxDist =  1300, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'SPAAA'		,	minPerSite = 0 , maxPerSite = 1, minDist =  350, maxDist =  1300, probPerSite = 100, side = coalition.side.RED},
                      {class = 'MPDS'	  	,	minPerSite = 1 , maxPerSite = 1, minDist =  200, maxDist =  500, probPerSite = 30, side = coalition.side.RED},                             
                      {class = 'SHORAD'		,	minPerSite = 1 , maxPerSite = 1, minDist =  500, maxDist =  3500, probPerSite = 15, side = coalition.side.RED},                       
                  }
                },                  
                            
              }   -- targetDef             
  GEN.DEF_ValleyDef = {     	
                {
                  name = 'VEDF',  border = 'AOR', class = 'SPAAA'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'vdef', 	minPerZone = 1 , maxPerZone = 1 ,
                  probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, separation = 0,  precisePlacement = false,
                  mission = false, missionRadius = 100, missionName = 'AAA Site',
                  components = {
                      {class = 'HMG'	  	,	minPerSite = 1 , maxPerSite = 3, minDist =  150, maxDist =  2300, probPerSite = 100, side = coalition.side.RED},                    
                      {class = 'AAA-L'		,	minPerSite = 1 , maxPerSite = 2, minDist =  250, maxDist =  2300, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-M'		,	minPerSite = 1 , maxPerSite = 1, minDist =  350, maxDist =  2300, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'AAA-H'		,	minPerSite = 0 , maxPerSite = 1, minDist =  450, maxDist =  2300, probPerSite = 100, side = coalition.side.RED}, 
                      {class = 'SPAAA'		,	minPerSite = 0 , maxPerSite = 1, minDist =  550, maxDist =  2300, probPerSite = 100, side = coalition.side.RED},
                      {class = 'MPDS'	  	,	minPerSite = 1 , maxPerSite = 1, minDist =  200, maxDist =  2500, probPerSite = 30, side = coalition.side.RED},                             
                      {class = 'SHORAD'		,	minPerSite = 1 , maxPerSite = 1, minDist =  500, maxDist =  2500, probPerSite = 100, side = coalition.side.RED},                       
                  }
                },                  
                            
              }   -- DEF_ValleyDef                 
    



end -- deployment settings
do -- Target Catalog
  GEN.targetCatalog = {}
  GEN.targetCatalog[1]  = {type = 'static', id = 'target-1-1', name = 'Ammo Storage', notes = '' , precise = 0, dpi = true}
  GEN.targetCatalog[2]  = {type = 'static', id = 'target-2-1', name = 'Ammo Storage', notes = '' , precise = 0, dpi = true}
  GEN.targetCatalog[3]  = {type = 'static', id = 'target-3-1', name = 'Ammo Storage', notes = '' , precise = 0, dpi = true}
  GEN.targetCatalog[4]  = {type = 'static', id = 'target-4-1', name = 'Ammo Storage', notes = '' , precise = 0, dpi = true}
  GEN.targetCatalog[5]  = {type = 'static', id = 'target-5-1', name = 'Refinery', notes = 'Tech combine and storage tanks\nPrimary target is the Tech combine',  precise = 250, dpi = false}
  GEN.targetCatalog[6]  = {type = 'static', id = 'target-6-1', name = 'Refinery', notes = 'Tech combine and storage tanks\nPrimary target is the Tech combine',  precise = 250, dpi = false}
  GEN.targetCatalog[7]  = {type = 'static', id = 'target-7-1', name = 'Refinery', notes = 'Tech combine and storage tanks\nPrimary target is the Tech combine',  precise = 250, dpi = false}
  GEN.targetCatalog[8]  = {type = 'static', id = 'target-8-1', name = 'Refinery', notes = 'Tech combine and storage tanks\nPrimary target is the Tech combine',  precise = 250, dpi = false}  
  GEN.targetCatalog[9]  = {type = 'static', id = 'target-9-1', name = "Dictator's residence", notes = '' , precise = 0, dpi = true} 
  GEN.targetCatalog[10] = {type = 'static', id = 'target-10-1', name = 'A/C Hardened Shelters', notes = '2 x Shelters\nDestroy the aircraft inside the shelters',  precise = 250, dpi = true}
  GEN.targetCatalog[11] = {type = 'static', id = 'target-11-1', name = 'A/C Hardened Shelters', notes = '2 x Shelters\nDestroy the aircraft inside the shelters',  precise = 250, dpi = true} 
  GEN.targetCatalog[12] = {type = 'static', id = 'target-12-1', name = 'A/C Hardened Shelters', notes = '2 x Shelters\nDestroy the aircraft inside the shelters',  precise = 250, dpi = true}   
  GEN.targetCatalog[13] = {type = 'static', id = 'target-13-1', name = 'A/C Hardened Shelters', notes = '2 x Shelters\nDestroy the aircraft inside the shelters',  precise = 250, dpi = true}  
  GEN.targetCatalog[14] = {type = 'static', id = 'target-14-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}    
  GEN.targetCatalog[15] = {type = 'static', id = 'target-15-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}    
  GEN.targetCatalog[16] = {type = 'static', id = 'target-16-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}  
  GEN.targetCatalog[17] = {type = 'static', id = 'target-17-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}  
  GEN.targetCatalog[18] = {type = 'static', id = 'target-18-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}  
  GEN.targetCatalog[19] = {type = 'static', id = 'target-19-1', name = 'Command Center', notes = '2 targets:\nC2 bunker and Comms Tower\nC2 bunker is the primary target',  precise = 250, dpi = true}  
  GEN.targetCatalog[20] = {type = 'static', id = 'target-20-1', name = "Dictator's residence", notes = '' , precise = 0, dpi = true} 
  GEN.targetCatalog[21] = {type = 'static', id = 'target-21-1', name = "Cargo Ship", notes = 'Sink the cargo ship and destroy\nthe nearby hangars, and armored vehicles\n The ship and hangars are the primary targets ' , precise = 250, dpi = false}   
  GEN.targetCatalog[22] = {type = 'static', id = 'target-22-1', name = 'Factory', notes = 'multiple targets',  precise = 250, dpi = false}  
  GEN.targetCatalog[23] = {type = 'static', id = 'target-23-1', name = 'Factory', notes = 'multiple targets',  precise = 250, dpi = false}  
  GEN.targetCatalog[24] = {type = 'static', id = 'target-24-1', name = 'Factory', notes = 'multiple targets',  precise = 250, dpi = false}  
  GEN.targetCatalog[25] = {type = 'static', id = 'target-25-1', name = 'POL site / Truck park', notes = 'multiple targets',  precise = 250, dpi = false}   
end
do -- airbases
  GEN.redAirbasesCatalog = {
      AIRBASE.Caucasus.Batumi
    , AIRBASE.Caucasus.Senaki_Kolkhi
    , AIRBASE.Caucasus.Kobuleti
    , AIRBASE.Caucasus.Kutaisi
  } -- GEN.redAirbasesCatalog 

  
    GEN.blueAirbases ={
      {id = AIRBASE.Caucasus.Sochi_Adler, CVN = false, LHA = false}
    , {id = AIRBASE.Caucasus.Mozdok, CVN = false, LHA = false}
    , {id = AIRBASE.Caucasus.Vaziani, CVN = false, LHA = false}

    
    , {id = 'CVN-74', CVN = true, LHA = false}
    , {id = 'LHA-1', CVN = false, LHA = true}
  }
  
  
end

--#################################################################################################################################################
-- #############   Initialization of globals (mission specific)																		                                  ############### 
--#################################################################################################################################################
do -- Globals
  GEN.Era = 0
  GEN.blueGROUPS = {}
  GEN.redGROUPS = {}
  GEN.clientConfig = {}
  GEN.movingGroups = {}
  GEN.movingGroups[coalition.side.RED] = {}
  GEN.movingGroups[coalition.side.BLUE] = {}
  
  GEN.mainMenu = nil

  GEN.playerUnits = {}
  GEN.playerGroups = {}
  GEN.PlayerKillTable ={}
  GEN.playerGroupsByID = {}
  GEN.ROEchangeRadiusOnMark = 1000
  GEN.ROEchangeRadiusOnShot = 1000
  GEN.maxWPmarkDist = 50
  GEN.minWPmarkDist = 20
  GEN.rootMenus = {}
  GEN.initMenu = {}

  GEN.rootMenus = {}
  GEN.ROEexclusions = {}
  GEN.samZones={}
  
  GEN.redIADS = nil
  GEN.RED_A2ADispatcher = nil
  GEN.red_DetectionSetGroup = nil
  GEN.samCount = 0
  GEN.samMarkedCount = 0

  GEN.target = {}
  GEN.redAirbases = {}
  GEN.IntZone1 = nil
  GEN.sqdnCounter = 0
  
  GEN.EscortDetection = {}
  GEN.EscortSetGroup = {}
  GEN.EscortCount = 0
  GEN.JammerCount = 0
  
  GEN.ewrTypes = {} 
  
  GEN.patrolZones ={
      {name = 'AOR', zone = ZONE_POLYGON:New( "AOR", GROUP:FindByName( "AOR" ))}
  }
  GEN.patrolCounter = 0
  GEN.blueA2G_DetectionSetGroup  = nil
  GEN.blueCAP_DetectionSetGroup = nil
  GEN.BLUE_A2GDispatcher = nil
  GEN.BLUE_A2ADispatcher = nil
  
  GEN.Jammers = {}
  
  GEN.markList = {}
  GEN.markedUnits = {}
  
  GEN.blueCC = nil
  GEN.blue_DetectionSetGroup  = nil
  GEN.blueRecceDetection = nil
  
  GEN.tankersBoom = {'Shell1-1','Shell2-1'} 
  GEN.tankersBasket = {'Texaco1-1','Texaco2-1'}
end
--#################################################################################################################################################
-- #############   Event Handlers											 	                                                   													############### 
--#################################################################################################################################################
GEN.EventHandler = {}
function GEN.EventHandler:onEvent(_eventDCS)

	if _eventDCS == nil or _eventDCS.initiator == nil then
		return true
	end

	local status, err = pcall(function(_event)

			if _event.id == world.event.S_EVENT_BIRTH  then
          local status,pn = pcall(_event.initiator:getPlayerName() )
          if pn  then  
            GEN.initUnit(_event.initiator:getName())
          else
            GEN.initPatrolJammer(_event.initiator:getName() )
          end
			
      elseif ( _event.id == world.event.S_EVENT_SHOOTING_START ) or (_event.id == world.event.S_EVENT_SHOT) then 
				
				timer.scheduleFunction(GEN.ShootingEvent, {_event},  timer.getTime() + mist.random(20,50) ) 	
        
			elseif (_event.id == world.event.S_EVENT_EJECTION or _event.id == world.event.S_EVENT_PILOT_DEAD ) and _event.initiator:getPlayerName() then 	
				
				GEN.showScore(_event.initiator:getName())		
			elseif (_event.id == world.event.S_EVENT_KILL)  then 
				GEN.KillEvent(_event)
			end --if (_event.id ==
								
		  -- ### End event processing

			return true
	end, _eventDCS) --  local status, err = pcall(function(_event)

	if (not status) then 
		local msg = string.format(">>>>>>>>>>> (v%s): Error while handling event %s",GEN.gVersion, err)
		env.error(msg,false)
	end
end
--===================================================================================================================================================
function GEN.KillEvent(_event)
	env.info('GEN.KillEvent() running',false)
	--if _event.target ~= nil  then
   -- env.info('GEN.KillEvent() target:'..mist.utils.tableShow(_event.target),false)
--  end
	
	if _event.initiator ~= nil and _event.target ~= nil  then
		local p =  _event.initiator:getPlayerName() 
		
		if not p then
			if _event.initiator:getCoalition() == 1 then
				p = 'Red AI'
			else
				p = 'Blue AI'
			end
		end
	
		if not GEN.PlayerKillTable[p] then
			GEN.PlayerKillTable[p] = {}
		end
		
		local t = _event.target:getTypeName()
		if t then
      local weapon = (_event.target:getCategory() == 2)
      if not weapon then
        if not GEN.PlayerKillTable[p][t] then
          GEN.PlayerKillTable[p][t] = {}
        end
        local c = 'Neutral'    
        if _event.target:getCoalition() <= 1   then
          c = 'Red'
        elseif _event.target:getCoalition() == 2 then
          c = 'Blue'
        end
        
        if not GEN.PlayerKillTable[p][t][c] then
          GEN.PlayerKillTable[p][t][c] = 1
        else
          GEN.PlayerKillTable[p][t][c] = GEN.PlayerKillTable[p][t][c]  + 1
        end
        env.info('GEN.KillEvent() p<'..p..'> t<'..t..'> c<'..c..'>',false)
      end
    end
	end
	
end -- function
--===================================================================================================================================================
function GEN.ShootingEvent(params,time)

	env.info('GEN.ShootingEvent() running',false)
	local _event = params[1]
	local _status,shooterName  pcall(function() return _event.initiator:getName() end)
	
	if _status then
		local UnitZoneTable = GEN.getUnitZoneTable('ALL')	
		
		local t = mist.getUnitsInMovingZones(UnitZoneTable, {shooterName}, GEN.ROEchangeRadiusOnShot, 'cylinder')
		
		
		for i = 1,d35.rowCount(t) do
			d35.setGroupOption(t[i]:getGroup():getName(),0,2) -- open fire
		end --for i = 1,d35.rowCount(t) do
	end	
	return nil
end --function
--===================================================================================================================================================
function GEN.initUnit(unitName)
	local unit = Unit.getByName(unitName)
	local groupID = unit:getGroup():getID()
	local groupName = unit:getGroup():getName()
	local unitType =  unit:getTypeName()
	local side = unit:getCoalition()
	local clientConfig = {
								groupID = groupID
							,	unitType = unitType
							,	side = side
							,	AltitudeUOM = 1
						}
		
	if not GEN.clientConfig[unitName] then -- new player
		dummy = 0
		
	else -- returning player
		dummy = 0
	end

	if not d35.inTable(unitName,GEN.playerUnits) then
		table.insert(GEN.playerUnits,unitName)
		if not d35.inTable(groupID,GEN.playerGroups) then
			table.insert(GEN.playerGroups,groupID)
      local isHelo = (unit:getDesc().category == 1)
			GEN.rootMenus[groupID] ={}
			GEN.playerGroupsByID[groupID] = groupName
      if GEN.Era ~= 0 then
        GEN.groupMenus(groupID, groupName,unitName)
      else
          table.insert(GEN.initMenu,{groupID = groupID, groupName = groupName, unitName = unitName})
      end
      

		end
	end
  GEN.clientConfig[unitName] = clientConfig
	return true
end
--===================================================================================================================================================
--#################################################################################################################################################
-- #############   mission generation code						                                          			 	  													############### 
--#################################################################################################################################################
function GEN.addGroups(_groupData, _side)
	local h,n  = d35.getGroupHealth(_groupData.name)
	local id =  d35.getNextID()
	local row = {
				name 		        = _groupData.name
			,	displayName     = _groupData.template.displayName
			,	position	      = _groupData.pos
			,	health0		      = h
			, isTarget	      = false
			, unitCount0        = n
			, templateGroupName	= _groupData.template.groupName
			, templateCategory	= _groupData.template.category
			,	afacPriority		  = _groupData.template.afacPri
			,	brief				      = _groupData.template.brief
			,	id					      =  id
		}
		
	env.info('GEN.addGroups(): Group: '.._groupData.name..' side: '.._side..' h0/n :'..h..'/'..n,false)
		
	if _side == 1 then
		GEN.redGROUPS[row.name] = row
	elseif _side == 2 then
		GEN.blueGROUPS[row.name] = row
	end
end-- function
--===================================================================================================================================================
function GEN.deployUnits(definition)
  env.info('GEN.deployUnits() in: ',false)
 
	for _,siteType in pairs(definition) do
    env.info('GEN.deployUnits() start: '..siteType.name,false)
    local border = siteType.border
		local zoneList = {}
		local TMPzoneList = mist.randomizeNumTable( {size = siteType.zoneQty,  lowerLimit = 1, upperLimit = siteType.zoneQty})
		for i = 1,siteType.deployZoneQty do
			table.insert(zoneList,TMPzoneList[i])
		end
		for _,z in pairs(zoneList) do
			if mist.random(1,100) <= siteType.probPerZone then
				local qty = mist.random(siteType.minPerZone,siteType.maxPerZone)
				env.info('GEN.deployUnits(): '..siteType.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..qty,false)
				if qty > 0 then
          local zoneName = string.format('%s-%s',siteType.zonePrefix,z)
          env.info('GEN.deployUnits(): deploying to zone: '..zoneName,false)
					local zone = trigger.misc.getZone(zoneName)
					for i = 1,qty do
						local templates, n = MGT.getTemplateList ({siteType.class}, siteType.side, GEN.Era)
            if n == 0 then 
              break
            end
						local template = templates[mist.random(1,n)]
            local radius =  zone.radius
            if  siteType.precisePlacement then
              radius = 0
            end
						local deployedGroups = MGT.populateLand({template}, 1, zone.point, border	, 0, radius, 0,0,siteType.separation,true,siteType.terrain,4000)
						local nGrp = d35.rowCount(deployedGroups) 
						env.info('GEN.deployUnits(): '..template.groupName,false)
						for j = 1,nGrp do
							local site = deployedGroups[j]
              local g = Group.getByName(site.name)
              local units = g:getUnits()
              local G = GROUP:FindByName(site.name)
              local S = SUPPRESSION:New(G)
							GEN.addGroups(site,siteType.side)-- group to red list	
							-- do anything aditional at site level
              -- add supression
              if d35.inTable('Suppresion',template.properties) then
                S:Fallback(false)
                S:Takecover(false)
              end
              local ewrType = ''
              if d35.inTable('IADS-CP',template.properties) then  ---- ----------------------------------- IADS- CP
                local commandCenter= units[1]
                GEN.redIADS:addCommandCenter(commandCenter)
                env.info('GEN.deployUnits(): set as IADS HQ',false)
              elseif d35.inTable('IADS-EWR',template.properties) then   ---- ----------------------------------- IADS- EWR
                local ewr = units[1]
                GEN.redIADS:addEarlyWarningRadar(ewr:getName())  
                ewrType = ewr:getTypeName()
                env.info('GEN.deployUnits(): set as IADS EWR ('.. ewrType .. ')',false)
                if not d35.inTable(ewrType,GEN.ewrTypes ) then
                  table.insert( GEN.ewrTypes , ewrType)
                end
              elseif d35.inTable('IADS-SAM',template.properties) then  ---- ----------------------------------- IADS- SAM
                -- add zone used to list so it can be exclude from false intelligence 
                table.insert(GEN.samZones,zoneName)
                GEN.redIADS:addSAMSite(site.name)
                GEN.samCount = GEN.samCount + 1
                env.info('GEN.deployUnits(): set as IADS SAM',false)  
                GEN.markSAM(site,GEN.samDetectionProb)
              end
              if siteType.mission then
                local g = Group.getByName(site.name)
                local units = g:getUnits()
                local u = units[1]
                local pos = u:getPoint()
                if ewrType == '' then
                  GEN.markTarget(pos,siteType.missionName, siteType.preciseMission)
                else
                   GEN.markTarget(pos,siteType.missionName..' ('..ewrType..')', siteType.preciseMission)
                end
              end

              -- Deploy site components 
							env.info('GEN.deployUnits(): components '..d35.rowCount(siteType.components),false)
							if d35.rowCount(siteType.components) > 0 then
								for _,def in pairs(siteType.components) do
									if mist.random(1,100) <= def.probPerSite then
										local dqty = mist.random(def.minPerSite,def.maxPerSite)
										env.info('MGT.deployUnits(): component '..def.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..dqty,false)
										if dqty > 0 then
											local dtemplates, dn = MGT.getTemplateList ({def.class}, def.side, GEN.Era)
                      if dn == 0 then 
                        break
                      end
											local dtemplate = dtemplates[mist.random(1,dn)]
											local ddeployedGroups = MGT.populateLand({dtemplate}, dqty, site.pos, border , def.minDist, def.maxDist, 0,0,0,false,{'LAND'},1000)
											local dnGrp = d35.rowCount(ddeployedGroups) 
											env.info('MGT.deployUnits(): component '..dtemplate.groupName,false)
											for dj = 1,dnGrp do
												local grp = ddeployedGroups[dj]
												GEN.addGroups(grp,def.side)-- group to red list		
												-- do anything aditional at component level

                        -- add supression
                        if d35.inTable('Suppresion',dtemplate.properties) then
                          local G = GROUP:FindByName(grp.name)
                          local S = SUPPRESSION:New(G)
                          S:Fallback(false)
                          S:Takecover(false)
                        end
                        if  d35.inTable('IADS-SAM',dtemplate.properties) then ---- ----------------------------------- IADS- SAM
                          -- add zone used to list so it can be exclude from false intelligence 
                            table.insert(GEN.samZones,zoneName)
                            GEN.redIADS:addSAMSite(grp.name)  
                            GEN.markSAM(grp,GEN.samDetectionProb)
                            GEN.samCount = GEN.samCount + 1
                            env.info('GEN.deployUnits(): set as IADS SAM',false)
                        end
											end--for dj = 1,dnGrp do
										end--if dqty > 0 then
									end --if mist.random(1,100) <= def.probPerSite then
								end--for _,def in pairs(siteType.component) do
							end -- if MGT.rowCount(siteType.component) > 0 then					
						end	--for j = 1,nGrp do		
					end -- for i = 1,qty do
				end -- if qty > 0 then
			end --if mist.random(1,100) <= siteType.probPerZone then
		end -- for _,z = 1 in pairs(zoneList) do
    env.info('GEN.deployUnits() end: '..siteType.name,false)
	end --for _,siteType in pairs(MGT.UnitsDef) do

	env.info('GEN.deployUnits() out: ',false)

end -- function
--===================================================================================================================================================
function GEN.deployRedAirInterceptors(base, groupNames, selectedType)

  if d35.chance(GEN.interceptorsProb) then
    GEN.sqdnCounter = GEN.sqdnCounter + 1
    local SQDNname = base..'('..selectedType..') #'..GEN.sqdnCounter
    GEN.RED_A2ADispatcher:SetSquadron(SQDNname, base, groupNames , 4)
    GEN.RED_A2ADispatcher:SetSquadronTakeoffFromParkingHot(SQDNname)
    GEN.RED_A2ADispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
    GEN.RED_A2ADispatcher:SetSquadronGrouping(SQDNname, 2 )
    GEN.RED_A2ADispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
    GEN.RED_A2ADispatcher:SetSquadronGci(SQDNname, 500, 1000 )
  end
end-- function
--===================================================================================================================================================
function GEN.deploy(era)
  env.info('GEN.deploy() starts era:'..era,false)
  missionCommands.removeItemForCoalition(coalition.side.BLUE , GEN.mainMenu )
  GEN.Era = era
  
  
  if d35.rowCount(GEN.initMenu) > 0 then
    for _,r in pairs(GEN.initMenu) do
       GEN.groupMenus(r.groupID, r.groupName, r.unitName)
    end
  end
  GEN.red_DetectionSetGroup = SET_GROUP:New()
	GEN.red_DetectionSetGroup:FilterPrefixes( {"R-EWR"} ) -- Depends on IADS EWR network
	GEN.red_DetectionSetGroup:FilterStart()	
  
  local redA2ADetection = DETECTION_AREAS:New( GEN.red_DetectionSetGroup, 300000 )	 
  GEN.RED_A2ADispatcher = AI_A2A_DISPATCHER:New( redA2ADetection )
  GEN.RED_A2ADispatcher:SetEngageRadius( 300000 )
  
  GEN.IntZone1 = ZONE_POLYGON:New( "IntZone1", GROUP:FindByName( 'AOR') )
	GEN.RED_A2ADispatcher:SetBorderZone( GEN.IntZone1 )

  
  GEN.redIADS = SkynetIADS:create('RED')
  GEN.redIADS:addMooseSetGroup(GEN.red_DetectionSetGroup)
  
  GEN.createBlueDispachers()
  
  GEN.deployUnits(GEN.DEF_IADS)
  GEN.deployUnits(GEN.DEF_AAAH)
  GEN.deployUnits(GEN.DEF_ABDEF)
  GEN.deployUnits(GEN.DEF_ValleyDef)

  GEN.DeployDecoys()
  
  GEN.selectRedAirbases()

  GEN.SelectTargets()

  GEN.redIADS:activate()
  GEN.patrolMenus()
  
 
  -- start recon
  GEN.blue_DetectionSetGroup = SET_GROUP:New()
	GEN.blue_DetectionSetGroup:FilterPrefixes( {  "B-"} ) -- Depends on IADS EWR network
	GEN.blue_DetectionSetGroup:FilterStart()	
  local G = GROUP:FindByName("BlueHQ")
  GEN.blueCC = COMMANDCENTER:New( G, "BlueHQ" )
  GEN.blueRecceDetection = DETECTION_UNITS:New( GEN.blue_DetectionSetGroup  )
  GEN.blueRecceDetection:SetRefreshTimeInterval( 30 )
  GEN.blueRecceDetection:SetDistanceProbability(0.5)
  GEN.blueRecceDetection:SetAlphaAngleProbability(0.5)
  
  GEN.blueRecceDetection:Start()
  timer.scheduleFunction(GEN.markCleanUp, {},  timer.getTime() + 120 )
  trigger.action.setUserFlag('MissionGenerated', true)
  env.info('GEN.deploy() ends ',false)
  trigger.action.outText( 'Deployment completed! ', 1 )
end -- function
--===================================================================================================================================================
function GEN.getUnitZoneTable(_side)
	-- get one alive unit per red group
	local side = _side
	if not side then
		side = 'RED'
	end
	local t = {}
	if side == 'RED' or side == 'ALL' then 
		for _,v in pairs(GEN.redGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'RED' or side =- 'ALL' then 
	if side == 'BLUE' or side == 'ALL' then 
		for _,v in pairs(GEN.blueGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'BLUE' or side =- 'ALL' then 
	return t
end -- function
--===================================================================================================================================================
function GEN.showKills(_groupName)
	local rpt = ''
	env.info('GEN.showKills start',false)
	if d35.rowCount(GEN.PlayerKillTable) > 0 then
		for player,killsCoalition in pairs(GEN.PlayerKillTable) do
			rpt = string.format('%s%s :\n',rpt,player)
			for t,kc in pairs(killsCoalition) do
				for c,k in pairs(kc) do
					rpt = string.format('%s   -> %s   <%s>(x%s)\n',rpt,t,c,k)
				end
			end
		end		
	else
		rpt = 'nothing to report'
	end
	
	d35.messageToGroup(_groupName,rpt,30)
	env.info('GEN.showKills end',false)

end -- function
--===================================================================================================================================================
function GEN.showScore(_groupName)
	local TU = 0
	local TG = 0
  local msg = ''
	
	-- agregate RED data
  local rTOO = 0
	local rH0 = 0
	local rH = 0
	local rN0 = 0
	local rN = 0
	for _,grpdata in pairs(GEN.redGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		rH0 = rH0 + grpdata.health0
		rH = rH + h
		rN0 = rN0 + grpdata.unitCount0 
		rN = rN + n
		if h <=0 then
      rTOO = rTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0
--[[
  -- agregate BLUE data
  local bTOO = 0
	local bH0 = 0
	local bH = 0
	local bN0 = 0
	local bN = 0    
	for _,grpdata in pairs(GEN.blueGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		bH0 = bH0 + grpdata.health0
		bH = bH + h
		bN0 = bN0 + grpdata.unitCount0 
		bN = bN + n
		if h <=0 then
      bTOO = bTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0
--]]
  
	
	
	msg = 'IADS Status \n'
	msg = string.format('%s   Strength: %s%%\n',msg,mist.utils.round(rH*100/rH0, 2))
	--msg = string.format('%s   Groups destroyed: %s\n',msg,rTOO)
	msg = string.format('%s   Units destroyed: %s\n',msg,(rN0-rN))
  
  if d35.rowCount(GEN.ewrTypes) > 0 then
    local ewrType = ''
    for _,ewrT in pairs(GEN.ewrTypes) do
      if ewrType ~= '' then
        ewrType = ewrType..', '..ewrT
      else
        ewrType = ewrT
      end
    end
    msg = string.format('%s   EWR Types: %s\n',msg, ewrType)
  end

	msg = string.format('%s\n< %s / %s >',msg,TG,TU)
	
	
	d35.messageToGroup(_groupName,msg,20)
end-- function
--===================================================================================================================================================
function GEN.markSAM(site,prob)
 if d35.chance(prob) then
    local r = 0
    
   
    if site.template.displayName  == 'SA-2 Site' then
      r = 45000  
    elseif site.template.displayName  == 'SA-3 Site' then
      r = 25000   
    elseif site.template.displayName  == 'SA-5 Site' then
      r = 99000         
    elseif site.template.displayName == 'SA-6 Btty.' then
      r = 36000    
    elseif site.template.displayName == 'SA-8' then
      r = 14000    
    elseif site.template.displayName == 'SA-10 Site' then
      r = 120000          
    elseif site.template.displayName == 'SA-11' then
      r = 35500  
    elseif site.template.displayName == 'SA-15' then
      r = 12000        
    end
    local g = Group.getByName(site.name)
    local units = g:getUnits()
    local u = units[1]
    local pos = u:getPoint()
    pos = mist.utils.makeVec3GL(mist.getRandPointInCircle(pos,1000))
    local C = COORDINATE:NewFromVec3(pos)
    C:MarkToAll(site.template.displayName..'. Last seen '..mist.random(0,36)..' hour(s) ago')
    C:CircleToAll(r, 2, {1,0,0}, 1, {1,1,0}, 0.10, 1, true)    
  end
end -- function          
--===================================================================================================================================================
function GEN.markTarget(pos,mission, precise, _mark )
    local mark = _mark
    if mark == nil then
      mark = true
    end
    local size = 5000
    local pos0 = mist.utils.makeVec3GL(mist.getRandPointInCircle(pos,precise))
    local pos1 =  mist.vec.add(pos0,{x = size, y = 0, z= -size}) 
    local pos2 = mist.vec.add(pos0,{x = -size, y = 0, z= size}) 
    local C = COORDINATE:NewFromVec3(pos0)
    local C1 = COORDINATE:NewFromVec3(pos1)
    local C2 = COORDINATE:NewFromVec3(pos2)
    if mark then
      C:MarkToAll(mission)
    end
    C1:RectToAll(C2, 2, {0.25,0.25,0.25}, 1, {0.5,0.5,0.5}, 0.15, 1, true)
    C1:TextToAll(mission, 2, {1,1,1}, 1, {0.5,0.5,0.5}, 0, 20, true)
    GEN.samMarkedCount = GEN.samMarkedCount + 1
end -- function  

--===================================================================================================================================================
function GEN.DeployDecoys()
  local decoyCount = GEN.samCount - GEN.samMarkedCount
  local failSafe = 2000
  while decoyCount > 0 and failSafe > 0 do
    local i = mist.random(1,5)
    local j = mist.random(1,12)
    local zoneName = 'sam-'..i..'-'..j
    if not d35.inTable(n,GEN.samZones) then
      local templates, n = MGT.getTemplateList ({'DECOY'}, coalition.side.RED, GEN.Era)
      local template = templates[mist.random(1,n)]
      local zone = trigger.misc.getZone(zoneName)
      local deployedGroups = MGT.populateLand({template}, 1, zone.point, 'AOR'	, 0, zone.radius, 0,0,100,true,{'LAND','ROAD'},4000)
      local site = deployedGroups[1]
      GEN.markSAM(site,100)
      decoyCount = decoyCount - 1
    end
    failSafe = failSafe - 1
  end
end-- function


--===================================================================================================================================================
function GEN.getStaticsInZone(zoneName,side)
  local zone = trigger.misc.getZone(zoneName)
  local n,list = d35.getObjectsInArea(Object.Category.STATIC,zone.point,zone.radius)
  local returnTable = {}
  if n > 0 then
    for _,o in pairs(list) do
      if o:getCoalition() == side then
        table.insert(returnTable,o)
      end
    end
  end
  return d35.rowCount(returnTable),returnTable
end -- function
--===================================================================================================================================================
function GEN.getTargetLife(ti)
  env.info('GEN.getTargetLife() ti <'..ti..'>',false)
  local n = 0
  local list = {}
  local life = 0
  
  if GEN.targetCatalog[ti].type == 'static' then
    n,list = GEN.getStaticsInZone( GEN.targetCatalog[ti].id ,coalition.side.RED)
  -- else if group get an unit list
  end
  
  if n > 0 then 
    for _,o in pairs(list) do
      life = life + o:getLife()
    end
  end
  
  return life
end -- function
--===================================================================================================================================================
function GEN.SelectTargets()
  local selected = {}
  for tc =1,GEN.MaxTargets do
    local t = d35.randomizeNumTable(1, 1,d35.rowCount(GEN.targetCatalog),selected)
    local i = t[1]
    table.insert(selected,i)
    GEN.target[tc] = {index = i, Life0 = 0}
    GEN.target[tc].Life0 = GEN.getTargetLife(GEN.target[tc].index)
    local markPos = nil
    if GEN.targetCatalog[i].type == 'static' then
      local zone = trigger.misc.getZone(GEN.targetCatalog[i].id)
      markPos = zone.point
      local Z = GEN.getPolygonZone(mist.utils.makeVec2(markPos), 5000)
      table.insert(GEN.patrolZones,{name = 'Target '..tc, zone = Z})
    end
    GEN.markTarget(markPos,'Target '..tc..': '..GEN.targetCatalog[i].name,GEN.targetCatalog[i].precise)
    local zn = GEN.targetCatalog[i].id
    local l = zn:len() - 2
    zn = zn:sub(1,l)
    GEN.DEF_targetDef[1].zonePrefix = zn
    GEN.deployUnits(GEN.DEF_targetDef)
  end --for
end -- function
--===================================================================================================================================================
function GEN.getTargetStatus(params)
  local groupName = params[1]
  local ti = params[2]
  local target = GEN.target[ti]
  local catalog  = GEN.targetCatalog[target.index]

  local targetLife = GEN.getTargetLife(target.index)
  local targetPerc = math.floor((targetLife*100/target.Life0)+0.5)
  local targetState = 'Operational'
  if targetPerc <= 10 then
    targetState = 'Destroyed'
  elseif targetPerc <= 50 then
    targetState = 'Heavily damaged'
  elseif targetPerc <= 70 then
    targetState = 'Moderately damaged'
  elseif targetPerc <= 90 then
    targetState = 'Lightly damaged'
  end

  local zone = trigger.misc.getZone(catalog.id)
  local name = catalog.name
  local notes =catalog.notes
  local pos = mist.utils.makeVec3GL(zone.point)
  local C = COORDINATE:NewFromVec3(pos)
  local DMS = string.gsub(C:ToStringLLDMS(),'LL DMS ','')
  local DDM = string.gsub(C:ToStringLLDDM(),'LL DDM ','')
  local MGRS = string.gsub(C:ToStringMGRS(),'MGRS ','')
  local status = 'Operational'
  local altM = math.floor(C.y)
  local altFT = math.floor(altM*3.281) 	
  local DPIs = ""

  if catalog.dpi then
    DPIs = GEN.getTargetDPIs(target.index)
  end

  local s = string.format("Target: <%s> %s\nStatus: %s\n Location:\n   %s\n   %s\n   %s\n   %sm / %sft\n%s\n%s",
        ti ,
        name,
        targetState,
        DMS,
        DDM,
        MGRS,
        altM,
        altFT,
        notes,
        DPIs
    )

  	d35.messageToGroup(groupName,s,30)
end -- function
--===================================================================================================================================================
function GEN.selectRedAirbases()
  local bases = d35.randomizeNumTable(GEN.MaxRedAirbases,1, d35.rowCount(GEN.redAirbasesCatalog ),{})
  for _,base in pairs(bases) do
    local templates, n = MGT.getTemplateList ({'INT'}, coalition.side.RED, GEN.Era)
    if n > 0 then
      local i = mist.random(1,n)
      local selectedType = templates[i].displayName
      local groupNames = {}
      for i = 1, n do
        if templates[i].displayName == selectedType then
          table.insert(groupNames,templates[i].groupName)
        end
      end
      GEN.deployRedAirInterceptors(GEN.redAirbasesCatalog[base],groupNames, selectedType)
      local pos = AIRBASE:FindByName(GEN.redAirbasesCatalog[base]):GetCoordinate():GetVec3()
      GEN.markTarget(pos,selectedType,0,false)
    end --   if n > 0 then
  end --for _,base in pairs(bases) do
end -- function
--===================================================================================================================================================
function GEN.smokeTargets()
  for i = 1,GEN.MaxTargets do
    local zone = trigger.misc.getZone(GEN.targetCatalog[GEN.target[i].index].id)
    local pos = mist.utils.makeVec3GL(zone.point)
    local C = COORDINATE:NewFromVec3(pos)
    C:SmokeRed()
  end
end --function
--===================================================================================================================================================
function GEN.illuminateTargets()
  for i = 1,GEN.MaxTargets do
    local zone = trigger.misc.getZone(GEN.targetCatalog[GEN.target[i].index].id)
    local pos = mist.utils.makeVec3GL(zone.point)
    local C = COORDINATE:NewFromVec3(pos)
    C.y = C.y + 500
    C:IlluminationBomb()
  end
end --function
--===================================================================================================================================================
function GEN.groupMenus(groupID, groupName, unitName)
  
  GEN.rootMenus[groupID]['Intelligence'] =  missionCommands.addSubMenuForGroup(groupID,'Intelligence',nil)
  GEN.rootMenus[groupID]['ATO'] =  missionCommands.addSubMenuForGroup(groupID,'A.T.O',GEN.rootMenus[groupID]['Intelligence'] )
  missionCommands.addCommandForGroup(groupID,"IADS Status", GEN.rootMenus[groupID]['Intelligence'] , GEN.showScore, groupName) 
  missionCommands.addCommandForGroup(groupID,"Kills Summary", GEN.rootMenus[groupID]['Intelligence'] ,GEN.showKills, groupName )
  missionCommands.addCommandForGroup(groupID,"Mark targets", GEN.rootMenus[groupID]['Intelligence'] ,GEN.smokeTargets, {} )
  missionCommands.addCommandForGroup(groupID,"Illuminate targets", GEN.rootMenus[groupID]['Intelligence'] ,GEN.illuminateTargets, {} )
 
  for i = 1, GEN.MaxTargets do
    missionCommands.addCommandForGroup(groupID,"Target "..i,  GEN.rootMenus[groupID]['ATO']  ,GEN.getTargetStatus, {groupName,i} )
  end
      
  GEN.rootMenus[groupID]['escort'] = missionCommands.addSubMenuForGroup(groupID, 'Escort ' ,nil)

  local sead = missionCommands.addSubMenuForGroup(groupID, 'SEAD ' ,GEN.rootMenus[groupID]['escort'] )
  for _,s in pairs(GEN.blueAirbases) do
    local start = missionCommands.addSubMenuForGroup(groupID, s.id ,sead) 
    local templates, n = MGT.getTemplateList ({'SEAD'}, coalition.side.BLUE, GEN.Era )
    for _,t in pairs(templates) do
      if (s.CVN and d35.inTable('CVN',t.properties))
        or (s.LHA and d35.inTable('LHA',t.properties))
        or (not s.CVN and not s.LHA)
      then
        missionCommands.addCommandForGroup(groupID, t.displayName , start, GEN.deployEscort, {s,t,groupID, unitName,'SEAD'})
      end
    end -- for _,t in pairs(templates) do     
  end --for _,s in pairs(GEN.blueAirbases) do

  
  local cap = missionCommands.addSubMenuForGroup(groupID, 'CAP ' ,GEN.rootMenus[groupID]['escort'] )
  for _,s in pairs(GEN.blueAirbases) do
    local start = missionCommands.addSubMenuForGroup(groupID, s.id ,cap) 
    local templates, n = MGT.getTemplateList ({'CAP'}, coalition.side.BLUE, GEN.Era )
    for _,t in pairs(templates) do
      if (s.CVN and d35.inTable('CVN',t.properties))
        or (s.LHA and d35.inTable('LHA',t.properties))
        or (not s.CVN and not s.LHA)
      then
        missionCommands.addCommandForGroup(groupID, t.displayName , start, GEN.deployEscort, {s,t,groupID, unitName,'CAP'})
      end
    end -- for _,t in pairs(templates) do     
  end --for _,s in pairs(GEN.blueAirbases) do
  
  local ew = missionCommands.addSubMenuForGroup(groupID, 'EW (Jamming) ' ,GEN.rootMenus[groupID]['escort'] )
  for _,s in pairs(GEN.blueAirbases) do
    local start = missionCommands.addSubMenuForGroup(groupID, s.id ,ew) 
    local templates, n = MGT.getTemplateList ({'EW'}, coalition.side.BLUE, GEN.Era )
    for _,t in pairs(templates) do
      if (s.CVN and d35.inTable('CVN',t.properties))
        or (s.LHA and d35.inTable('LHA',t.properties))
        or (not s.CVN and not s.LHA)
      then
        missionCommands.addCommandForGroup(groupID, t.displayName , start, GEN.deployEscort, {s,t,groupID, unitName,'EW'})
      end
    end -- for _,t in pairs(templates) do     
  end --for _,s in pairs(GEN.blueAirbases) do
  
 

end -- function
--===================================================================================================================================================
function GEN.deployEscort(params)
  local from = params[1]
  local template = params[2]
  local groupID = params[3]
  local clientName = params[4]
  local etype = params[5]

  local Client = CLIENT:FindByName( clientName )
  local Spawn =  SPAWN:New(template.groupName)
  local Escort = nil
  if etype == 'EW' then
    Escort = Spawn:SpawnAtAirbase( AIRBASE:FindByName( from.id), SPAWN.Takeoff.Cold,200,AIRBASE.TerminalType.OpenMedOrBig )
  else
    Escort = Spawn:SpawnAtAirbase( AIRBASE:FindByName( from.id), SPAWN.Takeoff.Cold)
  end
  GEN.EscortCount =   GEN.EscortCount + 1
  local EscortGroup = ESCORT:New( Client, Escort, string.format("%s/%s(%s)",template.displayName,GEN.EscortCount,etype) )
      :Menus()
      
      
  GEN.EscortSetGroup[GEN.EscortCount] = SET_GROUP:New():FilterPrefixes(Escort:GetName()):FilterStart()
  GEN.EscortDetection[GEN.EscortCount]  = DETECTION_AREAS:New( GEN.EscortSetGroup[GEN.EscortCount], 15000, 100 )
  
  GEN.EscortDetection[GEN.EscortCount]:BoundDetectedZones()
  GEN.EscortDetection[GEN.EscortCount]:SetRefreshTimeInterval( 15 )
      
  EscortGroup:SetDetection(GEN.EscortDetection[GEN.EscortCount] )
  
  Escort.ReportTargets = false
  if etype == 'EW' then
      local g = Group.getByName(Escort:GetName())
      local u = g:getUnits()
      GEN.JammerCount =   GEN.JammerCount  + 1
      local jammerSource = u[1]
      GEN.Jammers[GEN.JammerCount] = SkynetIADSJammer:create(jammerSource,   GEN.redIADS )
      GEN.Jammers[GEN.JammerCount]:addRadioMenu()
  end
end -- function
--===================================================================================================================================================
function GEN.patrolMenus()
  local patrol = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , 'Patrol ' ,nil)
  local sead = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , 'SEAD ' ,patrol)
  for _,r in pairs(GEN.patrolZones) do
    local dest = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , r.name ,sead)
    for _,s in pairs(GEN.blueAirbases) do
      local start = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , s.id ,dest) 
      local templates, n = MGT.getTemplateList ({'SEAD'}, coalition.side.BLUE, GEN.Era)
      for _,t in pairs(templates) do
        if (s.CVN and d35.inTable('CVN',t.properties))
          or (s.LHA and d35.inTable('LHA',t.properties))
          or (not s.CVN and not s.LHA)
        then
          missionCommands.addCommandForCoalition(coalition.side.BLUE , t.displayName , start, GEN.patrolSEAD, {r,s,t})
        end
      end -- for _,t in pairs(templates) do     
    end --for _,s in pairs(GEN.blueAirbases) do
  end -- for _,r in pairs(GEN.patrolZones) do
  
  local cap = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , 'CAP ' ,patrol)
  for _,r in pairs(GEN.patrolZones) do
    local dest = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , r.name ,cap)
    for _,s in pairs(GEN.blueAirbases) do
      local start = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , s.id ,dest) 
      local templates, n = MGT.getTemplateList ({'CAP'}, coalition.side.BLUE, GEN.Era)
      for _,t in pairs(templates) do
        if (s.CVN and d35.inTable('CVN',t.properties))
          or (s.LHA and d35.inTable('LHA',t.properties))
          or (not s.CVN and not s.LHA)
        then
          missionCommands.addCommandForCoalition(coalition.side.BLUE , t.displayName , start, GEN.patrolCAP, {r,s,t})
        end
      end -- for _,t in pairs(templates) do     
    end --for _,s in pairs(GEN.blueAirbases) do
  end -- for _,r in pairs(GEN.patrolZones) do
  
  local ew = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , 'EW ' ,patrol)
  for _,r in pairs(GEN.patrolZones) do
    local dest = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , r.name ,ew)
    for _,s in pairs(GEN.blueAirbases) do
      local start = missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , s.id ,dest) 
      local templates, n = MGT.getTemplateList ({'EW'}, coalition.side.BLUE, GEN.Era)
      for _,t in pairs(templates) do
        if (s.CVN and d35.inTable('CVN',t.properties))
          or (s.LHA and d35.inTable('LHA',t.properties))
          or (not s.CVN and not s.LHA)
        then
          missionCommands.addCommandForCoalition(coalition.side.BLUE , t.displayName , start, GEN.patrolEW, {r,s,t})
        end
      end -- for _,t in pairs(templates) do     
    end --for _,s in pairs(GEN.blueAirbases) do
  end -- for _,r in pairs(GEN.patrolZones) do
  
end -- function
--===================================================================================================================================================
function GEN.patrolEW(params)
  local region = params[1]
  local from = params[2]
  local template = params[3]

  
  GEN.patrolCounter = GEN.patrolCounter + 1
  local SQDNname = 'EW '..GEN.patrolCounter 

  GEN.BLUE_A2GDispatcher:SetSquadron(SQDNname, from.id, template.groupName , 1)
  GEN.BLUE_A2GDispatcher:SetSquadronTakeoffFromParkingCold(SQDNname)
  GEN.BLUE_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
  GEN.BLUE_A2GDispatcher:SetSquadronGrouping(SQDNname, 1 )
  GEN.BLUE_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
  GEN.BLUE_A2GDispatcher:SetSquadronSeadPatrol( SQDNname, region.zone, mist.utils.feetToMeters(15000), mist.utils.feetToMeters(25000))
  GEN.BLUE_A2GDispatcher:SetSquadronSeadPatrolInterval( SQDNname, 1, 1, 3,1 )
  if d35.inTable('basket',template.properties) then
    local tanker = GEN.tankersBasket[mist.random(1,d35.rowCount(GEN.tankersBasket))]
    GEN.BLUE_A2GDispatcher:SetSquadronTanker(SQDNname,tanker)
  elseif d35.inTable('boom',template.properties) then
    local tanker = GEN.tankersBoom[mist.random(1,d35.rowCount(GEN.tankersBoom))]
    GEN.BLUE_A2GDispatcher:SetSquadronTanker(SQDNname,tanker)
  end
  local msg = string.format('GEN.patrolEW() SQDN: %s (%s) deployed at %s',SQDNname,template.displayName,from.id)
  env.info(msg,false)
  msg = string.format('EW patrol(%s) deployed at %s to %s',template.displayName,from.id,region.name)
  trigger.action.outText( msg,10)   
end -- function
--===================================================================================================================================================
function GEN.patrolSEAD(params)
  local region = params[1]
  local from = params[2]
  local template = params[3]

  
  GEN.patrolCounter = GEN.patrolCounter + 1
  local SQDNname = 'SEAD '..GEN.patrolCounter 

  GEN.BLUE_A2GDispatcher:SetSquadron(SQDNname, from.id, template.groupName , 2)
  GEN.BLUE_A2GDispatcher:SetSquadronTakeoffFromParkingCold(SQDNname)
  GEN.BLUE_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
  GEN.BLUE_A2GDispatcher:SetSquadronGrouping(SQDNname, 2 )
  GEN.BLUE_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
  GEN.BLUE_A2GDispatcher:SetSquadronSeadPatrol( SQDNname, region.zone, mist.utils.feetToMeters(10000), mist.utils.feetToMeters(20000))
  GEN.BLUE_A2GDispatcher:SetSquadronSeadPatrolInterval( SQDNname, 1, 1, 3 , 1)
  if d35.inTable('basket',template.properties) then
    local tanker = GEN.tankersBasket[mist.random(1,d35.rowCount(GEN.tankersBasket))]
    GEN.BLUE_A2GDispatcher:SetSquadronTanker(SQDNname,tanker)
  elseif d35.inTable('boom',template.properties) then
    local tanker = GEN.tankersBoom[mist.random(1,d35.rowCount(GEN.tankersBoom))]
    GEN.BLUE_A2GDispatcher:SetSquadronTanker(SQDNname,tanker)
  end
  
  local msg = string.format('GEN.patrolSEAD() SQDN: %s (%s) deployed at %s',SQDNname,template.displayName,from.id)
  env.info(msg,false)
  msg = string.format('SEAD patrol(%s) deployed at %s to %s',template.displayName,from.id,region.name)
  trigger.action.outText( msg,10)
end -- function
--===================================================================================================================================================
function GEN.patrolCAP(params)
  local region = params[1]
  local from = params[2]
  local template = params[3]

  
  GEN.patrolCounter = GEN.patrolCounter + 1
  local SQDNname = 'CAP '..GEN.patrolCounter 
  
  GEN.BLUE_A2ADispatcher:SetSquadron(SQDNname, from.id, template.groupName , 2)
  GEN.BLUE_A2ADispatcher:SetSquadronTakeoffFromParkingCold(SQDNname)
  GEN.BLUE_A2ADispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
  GEN.BLUE_A2ADispatcher:SetSquadronGrouping(SQDNname, 2 )
  GEN.BLUE_A2ADispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
  GEN.BLUE_A2ADispatcher:SetSquadronCap( SQDNname,region.zone, mist.utils.feetToMeters(10000), mist.utils.feetToMeters(30000))
  GEN.BLUE_A2ADispatcher:SetSquadronCapInterval( SQDNname, 1, 1, 3 , 1 )
  if d35.inTable('basket',template.properties) then
    local tanker = GEN.tankersBasket[mist.random(1,d35.rowCount(GEN.tankersBasket))]
    GEN.BLUE_A2ADispatcher:SetSquadronTanker(SQDNname,tanker)
  elseif d35.inTable('boom',template.properties) then
    local tanker = GEN.tankersBoom[mist.random(1,d35.rowCount(GEN.tankersBoom))]
     GEN.BLUE_A2ADispatcher:SetSquadronTanker(SQDNname,tanker)
  end
  
  local msg = string.format('GEN.patrolCAP() SQDN: %s (%s) deployed at %s',SQDNname,template.displayName,from.id)
  env.info(msg,false)  
  msg = string.format('CAP patrol(%s) deployed at %s to %s',template.displayName,from.id,region.name)
  trigger.action.outText( msg,10)  
end -- function
--===================================================================================================================================================
function GEN.createBlueDispachers()
  GEN.blueCAP_DetectionSetGroup = SET_GROUP:New() 
  GEN.blueCAP_DetectionSetGroup:FilterPrefixes( { "B-CAP"} ) 
  GEN.blueCAP_DetectionSetGroup:FilterStart() 
  local blueA2ADetection = DETECTION_AREAS:New( GEN.blueCAP_DetectionSetGroup, 300000 )		
  GEN.BLUE_A2ADispatcher = AI_A2A_DISPATCHER:New( blueA2ADetection )
  GEN.BLUE_A2ADispatcher:SetEngageRadius( 500000 )
  
  GEN.blueA2G_DetectionSetGroup = SET_GROUP:New() 
  GEN.blueA2G_DetectionSetGroup:FilterPrefixes( { "B-SEAD","B-EW"} ) 
  GEN.blueA2G_DetectionSetGroup:FilterStart() 
  local blueA2GDetection = DETECTION_AREAS:New( GEN.blueA2G_DetectionSetGroup, 300000 )
  GEN.BLUE_A2GDispatcher = AI_A2G_DISPATCHER:New( blueA2GDetection )
  GEN.BLUE_A2GDispatcher:SetDisengageRadius( 500000 )
end -- function
--===================================================================================================================================================
function GEN.MissionGenerationMenu()
    GEN.mainMenu =  missionCommands.addSubMenuForCoalition(coalition.side.BLUE	 , 'Genetarate mission ' ,nil)
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Korea" ,  GEN.mainMenu , GEN.deploy, 1)
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Vietnam" ,  GEN.mainMenu , GEN.deploy, 2)
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Cold War 70's" ,  GEN.mainMenu , GEN.deploy, 3)
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Cold War 70's (MANPADS)" ,  GEN.mainMenu , GEN.deploy, 4) 
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Cold War 70's (MANPADS/LR SAM)" ,  GEN.mainMenu , GEN.deploy, 5) 
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Late Cold War" ,  GEN.mainMenu , GEN.deploy, 6)
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Late Cold War(MANPADS)" ,  GEN.mainMenu , GEN.deploy, 7)       
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Late Cold War(MANPADS/LR SAM)" ,  GEN.mainMenu , GEN.deploy, 8)       
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Modern (MANPADS)" ,  GEN.mainMenu , GEN.deploy, 9)       
    missionCommands.addCommandForCoalition(coalition.side.BLUE , "Modern (MANPADS/LR SMA)" ,  GEN.mainMenu , GEN.deploy, 10)  
end
--===================================================================================================================================================
function GEN.getTargetDPIs(ti)
  local n,list = GEN.getStaticsInZone( GEN.targetCatalog[ti].id ,coalition.side.RED)
  local ret = ''
  env.info('GEN.getTargetDPIs(): id: '..GEN.targetCatalog[ti].id ..' n: '..n,false)
  if n > 0 then
    for _,s in pairs(list) do
      local C = COORDINATE:NewFromVec3(s:getPoint())
      local DMS = string.gsub(C:ToStringLLDMS(),'LL DMS ','')
      local DDM = string.gsub(C:ToStringLLDDM(),'LL DDM ','')
      local MGRS = string.gsub(C:ToStringMGRS(),'MGRS ','')
      local altM = math.floor(C.y)
      local altFT = math.floor(altM*3.281) 	
      local t = s:getTypeName()
      local l = string.format('%s (elev.: %sm / %sft):\n     %s\n     %s\n     %s\n',t,altM,altFT,DMS,DDM,MGRS)
      ret = ret..l
    end -- for
    ret = "DPI's:\n"..ret
  end -- if n
  return ret
end -- function
--===================================================================================================================================================
 function GEN.getPolygonZone(center,radius)
  local step = 30 -- degrees
  local points = {}
  local a = 0
  local i = 1
  while a < 360 do
    --trigger.action.outText(mist.utils.tableShow(center),10)
    local x = center.x + (radius*math.cos( mist.utils.toRadian(a)))
    local y = center.y + (radius*math.sin( mist.utils.toRadian(a)))
    points[i] = {x = x, y = y}
    i = i +1
    a = a + step
  end
  return  ZONE_POLYGON:NewFromPointsArray('a', points)
end -- function
--===================================================================================================================================================
 function GEN.initPatrolJammer(unitName)
   if string.sub(unitName,1,4) == 'B-EW' then
      local jammerSource = Unit.getByName(unitName)
      GEN.JammerCount =   GEN.JammerCount  + 1
      GEN.Jammers[GEN.JammerCount] = SkynetIADSJammer:create(jammerSource,   GEN.redIADS )
      --GEN.Jammers[GEN.JammerCount]:addRadioMenu()
  end
 end
 --===================================================================================================================================================  
 function GEN.markUnit(_unit)
  
 -- env.info('>>>>> GEN.markUnit() start',false)
  if not GEN.markedUnits[_unit:GetName()] then
    GEN.markedUnits[_unit:GetName()]  = 0
  end

  if GEN.markedUnits[_unit:GetName()] == 0 then
    local markColor = ''
    local markShape = ''
    local desc = ''
    if _unit:HasAttribute("MANPADS") or _unit:HasAttribute("MANPADS AUX") then
      markColor = 'yellow'
      markShape = 'circle'
      desc = 'Infantry'
    elseif _unit:HasAttribute("Infantry") then
      markColor = 'yellow'
       markShape = 'circle'
      desc = 'Infantry'
    elseif _unit:HasAttribute("Fortifications") then
      markColor = 'black'
      markShape = 'trapezoid'
      desc = 'Fortification'
    elseif _unit:HasAttribute("AAA") then
      markColor = 'yellow'
      markShape = 'triangle'
       desc = 'AAA'      
    elseif _unit:HasAttribute("SAM")  or _unit:HasAttribute("SAM related") then
      markColor = 'red'
      markShape = 'triangle'
      desc = 'SAM'
    elseif _unit:HasAttribute("Tanks") then
      markColor = 'red'	
      markShape = 'square'
      desc = 'Armor'
    elseif _unit:HasAttribute("IFV") then
      markColor = 'red'
      markShape = 'square'
      desc = 'Armor'
    elseif _unit:HasAttribute("APC") then
      markColor = 'yellow'
      markShape = 'square'
      desc = 'Vehicles'
    elseif _unit:HasAttribute("Trucks") then
      markColor = 'yellow'
      markShape = 'square'
      desc = 'Vehicles'
    elseif _unit:HasAttribute("Helicopters") then
      markColor = 'bright yellow'
      markShape = 'diamond'
    elseif _unit:HasAttribute("Planes") then
      markColor = 'bright red'
      markShape = 'diamond'
    else 
      markColor = 'nomark'
      env.info('GEN.markUnit() nomark',false)
    end

    if markColor ~= 'nomark' then
      local id =  d35.getNextID()
      pos = _unit:GetCoord():GetVec3()
      local to = 3600
      
      if _unit:GetVelocityKMH() > 0 then
        to = 29
      end
      local row = {
                      name = _unit:GetName()
                    , id = id
                    , to =timer.getTime() + to
                  }        
      local color = {}
      if markColor == 'red' then
        color = {1,0,0,0.5}
      elseif markColor == 'yellow' then
         color = {1,1,0,0.5}
      elseif markColor == 'bright red' then
        color = {1,0,0,1}
      elseif markColor == 'bright yellow' then
         color = {1,1,0,1}         
      elseif markColor == 'black' then
        color = {0.25,0.25,0.25,0.5}
      elseif markColor == 'gray' then
        color = {0.5,0.5,0.5,0.5}
      end
      local size = 100
      if markShape ==  'circle' then
      trigger.action.circleToAll(
          coalition.side.BLUE 
        , id 
        , pos 
        , size
        , {0,0,0,1}
        , color
        , 1
        , true
        , ''
      )         
    else
        local p1 =   {}
        local p2 =   {}
        local p3 =   {}
        local p4 =   {}
      if markShape ==  'square' then
        size = 100
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= -size}) 
        p2 =  mist.vec.add(pos,{x = size, y = 0, z= size}) 
        p3 =  mist.vec.add(pos,{x = -size, y = 0, z= size}) 
        p4 =  mist.vec.add(pos,{x = -size, y = 0, z= -size}) 
      elseif markShape ==  'triangle' then
        size = 150
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p2 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p3 =  mist.vec.add(pos,{x = -size * 0.5, y = 0, z= size*0.866}) 
        p4 =  mist.vec.add(pos,{x = -size *0.5, y = 0, z= -size*0.866})    
      elseif markShape ==  'diamond' then
        size = 135
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p2 =  mist.vec.add(pos,{x = 0 , y = 0, z= size}) 
        p3 =  mist.vec.add(pos,{x = -size, y = 0, z= 0})  
        p4 =  mist.vec.add(pos,{x = 0 , y = 0, z= -size})        
      elseif markShape ==  'trapezoid' then
        size = 110
        p1 =  mist.vec.add(pos,{x = size*0.8, y = 0, z= -size*0.5}) 
        p2 =  mist.vec.add(pos,{x = size*0.8, y = 0, z= size*0.5}) 
        p3 =  mist.vec.add(pos,{x = -size*0.8, y = 0, z= size}) 
        p4 =  mist.vec.add(pos,{x = -size*0.8, y = 0, z= -size})         
      end
      trigger.action.quadToAll(
            coalition.side.BLUE 
          , id
          , p1 
          , p2
          , p3
          , p4
          ,  {0, 0, 0, 1}
          , color
          , 1
          , true
          , ''
        )
      
    end
    
      GEN.markList[id] = row   
      GEN.markedUnits[_unit:GetName()] = id
      local msg = string.format('=============> GEN.markUnit(%s) shape: %s color: %s id: %s to:%s',_unit:GetName(),markShape,markColor,id,to)
    --  env.info(msg,false)
    end
  end
end -- function
--===================================================================================================================================================
function GEN.markCleanUp(params,time)
  if d35.rowCount(GEN.markList) > 0 then
    local t = timer.getTime()
    for id,row in pairs(GEN.markList) do
      local remove = false
      if t >= row.to then
        remove = true
        --env.info('GEN.markCleanUp() id: '..id..' timeout',false)
      else
        local U = UNIT:FindByName(row.name)
        if U then
          if not U:IsAlive() then
            remove = true
           -- env.info('GEN.markCleanUp() id: '..id..' unit dead',false)
          end
        else
          remove = true
         -- env.info('GEN.markCleanUp() id: '..id..' unit does not exist',false)
        end
      end
      if remove then
        trigger.action.removeMark(id)
        GEN.markList[row.id] = nil
        GEN.markedUnits[row.name]  = 0
       -- env.info('GEN.markCleanUp() id: '..id..' removed',false)
      end
    end
  end
  return timer.getTime()+15
end -- function

--===================================================================================================================================================
 
 
 
 
--#################################################################################################################################################
-- #############   Main body   														                                                  												############### 
--#################################################################################################################################################
--
do

	-- load event handler
	world.addEventHandler(GEN.EventHandler)
  GEN.MissionGenerationMenu()
	-- Show AFAC Status
	trigger.action.outText( GEN.gName ..'- v'..GEN.gVersion, 1 )
end
